%define	lib_major 1
%define	lib_name %mklibname %{name}%{lib_major}
%define	devel_name %mklibname %{name} -d
%define	static_name %mklibname %{name} -d -s

%define libminizip %mklibname minizip %{lib_major}
%define minizip_devel %mklibname minizip -d

%bcond_without minizip
%bcond_without dietlibc

Summary:	The zlib compression and decompression library
Name:		zlib
Version:	1.2.12
#define		subrel 1
Release:	%mkrel 1
Group:		System/Libraries
License:	BSD
URL:		http://www.zlib.net/
Source0:	http://www.zlib.net/%{name}-%{version}.tar.gz
Patch1:		zlib-1.2.10-revert-uncompress2.patch

BuildRequires:	util-linux
%if %{with dietlibc}
BuildRequires:	dietlibc-devel
%endif
%if %{with minizip}
BuildRequires:	pkgconfig(zlib)
%endif

%description
The zlib compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  This version of the library supports only one compression method
(deflation), but other algorithms may be added later, which will have
the same stream interface.  The zlib library is used by many different
system programs.

%package -n	%{lib_name}
Summary:	The zlib compression and decompression library
Group:		System/Libraries
Requires(pre):	filesystem >= 2.1.9-18
Obsoletes:	libz, libz1, %{name}
Obsoletes:	%{name}%{lib_major} < 1.2.5
Provides:	libz = %{version}-%{release}
Provides:	libz1 = %{version}-%{release}
Provides:	%{name} = %{version}-%{release}
Conflicts:      libzlib1 < 1.2.9
Conflicts:      lib64zlib1 < 1.2.9

%description -n	%{lib_name}
The zlib compression library provides in-memory compression and
decompression functions, including integrity checks of the uncompressed
data.  This version of the library supports only one compression method
(deflation), but other algorithms may be added later, which will have
the same stream interface.  The zlib library is used by many different
system programs.

%package -n	%{devel_name}
Summary:	Header files and libraries for developing apps which will use zlib
Group:		Development/C
Requires:	%{lib_name} = %{version}-%{release}
Obsoletes:	libz1-devel libz-devel zlib-devel zlib1-devel
Obsoletes:	%{name}%{lib_major}-devel < 1.2.5
Provides:	libz-devel = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n	%{devel_name}
The zlib-devel package contains the header files and libraries needed
to develop programs that use the zlib compression and decompression
library.

Install the zlib-devel package if you want to develop applications that
will use the zlib library.

%package -n	%{static_name}
Summary:	Static libraries for developing apps which will use zlib
Group:		Development/C
Requires:	%{devel_name} = %{version}-%{release}
Provides:	%{name}-static-devel = %{version}-%{release}
Conflicts:	%{devel_name} < 1.2.11-9

%description -n %{static_name}
The zlib-static-devel package contains the static libraries needed
to develop programs that use the zlib compression and decompression
library.

Install the zlib-static-devel package if you want to develop applications that
will use the zlib library statically.

%if %{with minizip}
%package -n     %{libminizip}
Summary:        Minizip manipulates files from a .zip archive
Group:          System/Libraries

%description -n %{libminizip}
Minizip manipulates files from a .zip archive.

%package -n     %{minizip_devel}
Summary:        Development files for the minizip library
Group:          Development/C
Requires:       %{libminizip} = %{version}-%{release}
Requires:       zlib-devel = %{version}-%{release}
Provides:       libminizip-devel = %{version}-%{release}
Provides:       minizip-devel = %{version}-%{release}

%description -n %{minizip_devel}
This package contains the libraries and header files needed for
developing applications which use minizip.
%endif

%prep
%setup -q
%autopatch -p1

%build
#(peroyvind): be sure to remove -m64/-m32 flags as they're not overridable
RPM_OPT_FLAGS="`echo $RPM_OPT_FLAGS| sed -e 's/-m.. //g'` -O3"
mkdir objs
cp -a $(ls | grep -v objs) objs/
pushd objs
  CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="%{?ldflags}" \
  ./configure --shared --prefix=%{_prefix} --libdir=%{_libdir}
  %make_build
  make test
popd

%if %{with minizip}
pushd contrib/minizip
autoreconf --install
%configure --enable-static=no
%make_build
popd
%endif


%if %{with dietlibc}
mkdir objsdietlibc
cp -a $(ls | grep -v objs) objsdietlibc/
pushd objsdietlibc
  CFLAGS="-Os" CC="diet gcc" \
  ./configure --prefix=%{_prefix}
  %make_build libz.a
popd
%endif


%install
install -d %{buildroot}%{_prefix}
install -d %{buildroot}%{_libdir}

make install -C objs prefix=%{buildroot}%{_prefix} libdir=%{buildroot}%{_libdir}

%if %{with minizip}
pushd contrib/minizip
%make_install
popd
%endif

%if %{with dietlibc}
install -m644 objsdietlibc/libz.a -D %{buildroot}%{_prefix}/lib/dietlibc/lib-%{_arch}/libz.a
%endif

%if %{with minizip}
rm -fr %{buildroot}%{_libdir}/libminizip.la
# https://bugzilla.redhat.com/show_bug.cgi?id=1424609
# https://github.com/madler/zlib/pull/229
rm -fr %{buildroot}%{_includedir}/minizip/crypt.h
%endif

%files -n %{lib_name}
%doc README
%{_libdir}/libz.so.%{lib_major}{,.*}

%files -n %{devel_name}
%doc README ChangeLog doc/algorithm.txt
%{_mandir}/man3/zlib.3*
%{_libdir}/libz.so
%{_libdir}/pkgconfig/zlib.pc
%{_includedir}/zconf.h
%{_includedir}/zlib.h

%files -n %{static_name}
%{_libdir}/libz.a
%if %{with dietlibc}
%{_prefix}/lib/dietlibc/lib-%{_arch}/libz.a
%endif

%if %{with minizip}
%files -n %{libminizip}
%{_libdir}/libminizip.so.%{lib_major}{,.*}

%files -n %{minizip_devel}
%{_libdir}/pkgconfig/minizip.pc
%{_libdir}/libminizip.so
%{_includedir}/minizip/
%endif


%changelog
* Wed Mar 30 2022 tmb <tmb> 1.2.12-1.mga8
+ Revision: 1834779
- update to 1.2.12
- Fix a bug that can crash deflate on some input when using Z_FIXED (mga#30204)

* Sun Mar 08 2020 wally <wally> 1.2.11-9.mga8
+ Revision: 1554871
- split out static devel pkg

* Fri Feb 14 2020 umeabot <umeabot> 1.2.11-8.mga8
+ Revision: 1519149
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sun Sep 23 2018 umeabot <umeabot> 7.mga7-current
+ Revision: 1302060
- Mageia 7 Mass Rebuild

* Wed May 02 2018 daviddavid <daviddavid> 1.2.11-6.mga7
+ Revision: 1224461
- do not install crypt.h minizip header (rhbz#1424609)
  * looks like we get a breakage in sigil due that

* Fri Feb 09 2018 tmb <tmb> 1.2.11-5.mga7
+ Revision: 1199928
- sync with MGAA-2017-0125 from mga6

* Wed Mar 29 2017 neoclust <neoclust> 1.2.11-4.mga6
+ Revision: 1095154
- Add more conflicts

* Wed Mar 29 2017 neoclust <neoclust> 1.2.11-3.mga6
+ Revision: 1095142
- Add conflict to ease upgrade from mga5(mga#20562)

* Mon Feb 06 2017 zezinho <zezinho> 1.2.11-2.mga6
+ Revision: 1085045
- remove biarch build to allow simultaneous install of i586 and x86_64 versions

* Mon Jan 16 2017 luigiwalser <luigiwalser> 1.2.11-1.mga6
+ Revision: 1082005
- 1.2.11
- remove patch changing internal version (not needed)

* Mon Jan 09 2017 luigiwalser <luigiwalser> 1.2.10-3.mga6
+ Revision: 1080779
- revert addition of uncompress2 function in 1.2.9

* Mon Jan 09 2017 luigiwalser <luigiwalser> 1.2.10-2.mga6
+ Revision: 1080775
- change internal version to 1.2.9.1 to work around buggy maven

* Tue Jan 03 2017 luigiwalser <luigiwalser> 1.2.10-1.mga6
+ Revision: 1079972
- remove upstreamed patches and update URLs
- 1.2.10

* Tue Oct 04 2016 luigiwalser <luigiwalser> 1.2.8-10.mga6
+ Revision: 1058600
- add upstream patches to fix issues found by mozilla security audit

* Sun Jan 17 2016 daviddavid <daviddavid> 1.2.8-9.mga6
+ Revision: 925180
- switch to %%configure2_5x to fix build

* Fri Aug 21 2015 tmb <tmb> 1.2.8-8.mga6
+ Revision: 867778
- rebuild for new gcc

* Wed Oct 15 2014 umeabot <umeabot> 1.2.8-7.mga5
+ Revision: 747129
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 1.2.8-6.mga5
+ Revision: 730757
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 1.2.8-5.mga5
+ Revision: 690882
- Mageia 5 Mass Rebuild

* Wed Aug 20 2014 tv <tv> 1.2.8-4.mga5
+ Revision: 665832
- drop uclibc build

* Mon Dec 16 2013 boklm <boklm> 1.2.8-3.mga4
+ Revision: 557186
- Rebuild for new uclibc

* Sat Oct 19 2013 umeabot <umeabot> 1.2.8-2.mga4
+ Revision: 532944
- Mageia 4 Mass Rebuild

* Mon Jul 08 2013 luigiwalser <luigiwalser> 1.2.8-1.mga4
+ Revision: 451058
- 1.2.8

* Mon Jan 14 2013 umeabot <umeabot> 1.2.7-7.mga3
+ Revision: 387754
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Sep 17 2012 fwang <fwang> 1.2.7-6.mga3
+ Revision: 294833
- bump rel

* Mon Sep 17 2012 fwang <fwang> 1.2.7-5.mga3
+ Revision: 294829
- setarch merged into util-linux

* Sat Jul 21 2012 colin <colin> 1.2.7-4.mga3
+ Revision: 273158
- Update for usrmove

* Sat Jul 07 2012 dmorgan <dmorgan> 1.2.7-3.mga3
+ Revision: 268555
- Build minizip

* Tue May 29 2012 shlomif <shlomif> 1.2.7-1.mga3
+ Revision: 248898
- New version: 1.2.7

* Mon Jan 30 2012 fwang <fwang> 1.2.6-1.mga2
+ Revision: 203353
- new version 1.2.6

* Fri Oct 28 2011 tmb <tmb> 1.2.5-5.mga2
+ Revision: 159068
- split out uClibc-zlib(-devel) in separate rpms so basesystem-minimal
  does not require uClibc anymore.
- drop buildroot and defattr

* Sat Jan 08 2011 blino <blino> 1.2.5-3.mga1
+ Revision: 448
- imported package zlib

